{
******************************************************
*  PROSTA KLASA RYSOWANIA MAPY WIATA 2D             *
*  OPARTA NA KOMPONENCIE OMEGA                       *
*  Adam Lasko (oksal) Zbylitowska Gra 5.06.2006     *
*                                                    *
******************************************************
}

unit OmegaMapa;
interface
uses
    Windows,Classes,Controls,OmegaScreen,OmegaSurface,OmegaImageList;
type
  tMapa=class (TOmegaSurface)
   private
    fIdObraz,              //indeks obrazu z listy OmegaImageList
    fIdKlatka,             //indesk wycinanej klatki
    fIdPunkt               //Indeks obraz rysowanego punktu
                           :integer;
    fOmegaImageList        :TOmegaImageList;
    fKlatkaMapyWidth,      //rozmiary podstawowej klatki mapy swiata podane w pikselach
    fKlatkaMapyHeight,
    fRectCol,              //liczba kolumn i wierszy widocznego swiata
    fRectRow,
    fRectWidth,
    fRectHeight:           integer;
    fxGracz,                //wspolrzedne sledzenia gracza- Poloenie otego punktu
    fyGracz,
    fRectX,                //wspolrzedne centrum prostokata widocznosci mapy
    fRectY                 :single;
    fSkalaX                :real;
    fSkalaY                :real;
    //falga testu klikniecia
    fKliknieto             :boolean;
    fKliknietoX,
    fKliknietoY            :integer;
   published
    property KlatkaMapyWidth:integer write fKlatkaMapyWidth;
    property KlatkaMapyHeight:integer write fKlatkaMapyHeight;
    property RectCol       :integer write fRectCol;
    property RectRow       :integer write fRectRow;
    property IdObraz       :integer read fIdObraz  write fIdObraz;
    property IdKlatka      :integer read fIdKlatka write fIdKlatka;
    property IdPunkt       :integer read fIdPunkt  write fIdPunkt;
    property SkalaX        :real    read fSkalaX   write fSkalaX;
    property SkalaY        :real    read fSkalaX   write fSkalaY;
    property OmegaImageList:TOmegaImageList write fOmegaImageList;
    property OmegaScreen   :TOmegaScreen    write fOmegaScreen;
   public
    procedure MouseDown(Sender: TObject; Button: TMouseButton;
                        Shift: TShiftState; _X, _Y: Integer);
    procedure Ruch(const AVX,AVY:single);
    procedure UstawParametry(const AIdObraz,AIdKlatka,ALeft,ATop,ARectCol,ARectRow,AKlatkaMapyWidth,AKlatkaMapyHeight:integer);
    procedure UstawOmegaImageList(const AOmegaImageList:TOmegaImageList);
    procedure UstawSkale(const ASkalaX,ASkalaY:real);
    procedure Draw;
    constructor Create(const AOwner: TComponent;const AhWnd: hWnd);virtual;
  end;
var
  Mapa:tMapa;
implementation

procedure tMapa.MouseDown(Sender: TObject; Button: TMouseButton;
                        Shift: TShiftState; _X, _Y: Integer);
begin
 //tak sobie testowa procedur a zdarzenia klkniecia w obszarze mapy
 if Button = mbleft then fKliknieto :=true else fKliknieto:=false;
 fKliknietoX:=_x-x;
 fKliknietoY:=_y-y;
end;
procedure tMapa.Ruch(const AVX,AVY:single);
begin
 fxGracz:=AVx;
 fyGracz:=AVy;
 fRectX:=AVx;
 fRectY:=AVy;
 if fRectX<fRectWidth then fRectX:=fRectWidth;
 if fRectY<fRectHeight then fRectY:=fRectHeight;
 if fRectX>fOmegaImageList.ImageList.Items[idObraz].TileWidth -fRectWidth  then fRectX:=fOmegaImageList.ImageList.Items[idObraz].TileWidth  -fRectWidth;
 if fRectY>fOmegaImageList.ImageList.Items[idObraz].TileHeight-fRectHeight then fRectY:=fOmegaImageList.ImageList.Items[idObraz].TileHeight -fRectHeight;

end;
procedure tMapa.UstawParametry(const AIdObraz,AIdKlatka,ALeft,ATop,ARectCol,ARectRow,AKlatkaMapyWidth,AKlatkaMapyHeight:integer);
begin
  IdObraz :=AIdObraz;
  IdKlatka:=AIdKlatka;
  //ustaw rozmiary powierzchni mapy na podstwaie odczytanych wymiarw obrazu mapy
  Width :=fOmegaImageList.ImageList.items[fIdObraz].TileWidth;
  Height:=fOmegaImageList.ImageList.items[fIdObraz].TileHeight;
  //okre punkt zaczepienia gornego lewego rogu mapy
  X:=ALeft;
  Y:=ATop;
  //okrel dane prostokta widocznoci
  fRectCol         :=ARectCol;
  fRectRow         :=ARectRow;
  fKlatkaMapyWidth :=AKlatkaMapyWidth;
  fKlatkaMapyHeight:=AKlatkaMapyHeight;
  //ustal polowy dlugosci bokow rysowanego prostokta w przyjtej skali ;
  fRectWidth :=Round(fRectCol*fKlatkaMapyWidth *fSkalaX) div 2;
  fRectHeight:=Round(fRectRow*fKlatkaMapyHeight*fSkalaY) div 2;
end;
procedure tMapa.UstawOmegaImageList(const AOmegaImageList:TOmegaImageList);
begin
 OmegaImageList:=AOmegaImageList;
end;
constructor tMapa.Create(const AOwner: TComponent;const AhWnd: hWnd);
begin
  inherited Create(AOwner);
  SethWnd(AhWnd);
  fKliknieto:=false;
end;
procedure tMapa.UstawSkale(const ASkalaX,ASkalaY:real);
begin
 SkalaX:=ASkalaX;
 SkalaY:=ASkalaY;
end;
procedure  tMapa.Draw;
begin
  //rysuj obraz mapy
  fOmegaImageList.ImageList  .Items[fIdobraz].Draw(x,y,FIdKlatka);
  //rysuj ty punkt ledzenia gracza
  fOmegaImageList.ImageList  .Items[fIdPunkt].Draw(Round(x+fxGracz),Round(y+fyGracz),0);
  //rysuj prostokatn bia ramk
  fOmegaImageList.OmegaScreen.DrawRectangle(Round(x+fRectX-fRectWidth),
                                            Round(y+fRectY-fRectHeight),
                                            Round(x+fRectX+fRectWidth),
                                            Round(y+fRectY+fRectHeight),
                                            false,1,255,255,255);

  //rysuj may prostokat miejsca klkiniecia w obszarZe mapy
  //dodaem to w celach pogldowych 
  if fKliknieto then
  fOmegaImageList.OmegaScreen.DrawRectangle(x+fKliknietoX-10,
                                            y+fKliknietoY-5,
                                            x+fKliknietoX+10,
                                            y+fKliknietoY+5,
                                            false,1,255,0,0);

end;
end.
